describe('BaseModel', function() {
  it('requires a type attribute', function(){
    var mdl;
    spyOn(console, 'warn');
    mdl = new BaseModel();

    expect(console.warn).toHaveBeenCalled();
  });

  it('has a url ending in json', function() {
    var mdl = new (BaseModel.extend({urlRoot: '/foo'}));

    expect(mdl.url()).toMatch(/\.json$/);
  });

  it('has a JSON representation which includes .data', function() {
    var mdl = new BaseModel({urlRoot: '/foo'});

    expect(mdl.toJSON().data).toBeDefined();
  });

  it('can create a model for a resource', function() {
    var modelClass = BaseModel.forResource('foos');
    var instance = new modelClass();

    expect(typeof modelClass).toEqual('function');
    expect(instance.url()).toEqual('/foos.json');
    expect(instance.get('type')).toEqual('foos');
  });

  it('can give a model name for a resource', function() {
    App.Models.ModelNameTest = {};

    expect(
      BaseModel.modelClassForResource('model_name_tests')
    ).toEqual(App.Models.ModelNameTest);
  });
});
