App.Models = (App.Models || {});
App.Models.RelationshipTest = BaseModel.extend();
App.Models.RelationshipTest.Collection =  BaseCollection.extend();

describe('Rev.Store', function() {
  var store;
  var projectDefaults = {
    links: {
      'relationship-tests': {
        linkage: {}
      }
    }
  };

  beforeEach(function() {
    store = new Rev.Store();
    store.new('project', BaseModel, projectDefaults);
  });

  it('can set a linkage', function() {
    store.setLink(
      'project',
      'relationship-tests',
      [{id: '1', type: 'relationship-tests'}]
    );

    expect(
      store.linksAndRelationships(store.project)['relationship-tests'].data
    ).toEqual([{id: '1', type: 'relationship-tests'}]);
  });

  it('can set a relation', function() {
    store.setRelation('project', 'relationship-tests', [
      {id: '2', type: 'relationship-tests', name: 'foo'},
      {id: '4', type: 'relationship-tests', name: 'bar'}
    ]);

    expect(
      store.linksAndRelationships(store.project)['relationship-tests'].data.length
    ).toEqual(2);

    expect(
      store['relationship-tests'].get('2').attributes
    ).toEqual(
      {id: '2', type: 'relationship-tests', name: 'foo'}
    );

    expect(
      store['relationship-tests'].get('4').attributes
    ).toEqual(
      {id: '4', type: 'relationship-tests', name: 'bar'}
    );
  });

  it('can get a relation which has been set', function() {
    var relatedObjects;
    store.setRelation('project', 'relationship-tests', [
      {id: '2', type: 'relationship-tests', name: 'foo'},
      {id: '4', type: 'relationship-tests', name: 'bar'}
    ]);

    relatedObjects = store.getLink('project', 'relationship-tests');
    expect(relatedObjects[0].get('name')).toEqual('foo');
    expect(relatedObjects[1].get('name')).toEqual('bar');
  });
});
